/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: GetBbsCategoryTreeCommand.cs,v 1.6 2003/05/21 17:58:17 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.IO;
using System.Net;
using System.Text;
using System.Windows.Forms;

using Zigumo.Model;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// BBSj[擾R}h
	/// </summary>
	public class GetBbsCategoryTreeCommand : Zigumo.CommandObject.ControllerCommand
	{
		/// <summary>
		/// CategoryTreeVieŵ߂̃fQ[g
		/// </summary>
		public delegate void UpdateCategoryDelegate();
		/// <summary>
		/// {R}hdɎsȂ߂̃tO
		/// </summary>
		private static bool lockFlag = false;
		/// <summary>
		/// JeSc[i[nodes
		/// </summary>
		private TreeNodeCollection nodes;

		public GetBbsCategoryTreeCommand(TreeNodeCollection nodes) {
			this.nodes = nodes;
		}

		/// <summary>
		/// {R}hdɎsȂ߂lock\bh
		/// lockfalseȂtrueɐݒ肵lockBtrueȂlocks|falseŕԂ
		/// </summary>
		/// <returns></returns>
		private static bool CheckLock() {
			lock(typeof(GetBbsCategoryTreeCommand)) {
				if(lockFlag)
					return false;
				lockFlag = true;
				return true;
			}
		}
		/// <summary>
		/// lock\bh
		/// </summary>
		private static void Unlock() {
			lock(typeof(GetBbsCategoryTreeCommand)) {
				lockFlag = false;
			}
		}

		public override void Execute() {
			model.Log.Write("Get BBS menu from " + model.BbsCategoryUrl);

			if(!CheckLock()) {//R}hlock
				model.Log.Write("Get BBS menu command faild, command is locked");
				return;
			}

			//Xe[^Xo[XV
			SetStatusBarDelegate setStatusBarDelegate = new SetStatusBarDelegate(commandController.Form.SetStatusBar);
			object[] obj = { "BBSj擾..." };
			commandController.Form.BeginInvoke(setStatusBarDelegate, obj);

			StringBuilder strBuff = new StringBuilder();
			try {
				string url = model.BbsCategoryUrl;
				HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(url);
				httpReq.UserAgent = "Monazilla/1.00 (" + model.ZigumoUserAgent + ")";
				HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();

				//Xg[oRŎ擾
				Stream st = httpRes.GetResponseStream();
				StreamReader sr = new StreamReader(st, Encoding.GetEncoding("Shift_JIS"));

				Char[] buff = new Char[256];
				int count = sr.Read(buff, 0, buff.Length);
				while (count > 0) {
					strBuff.Append(new String(buff, 0, count));
					count = sr.Read(buff, 0, 256);
				}
				
				sr.Close();
				st.Close();
			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			}

			//p[X
			TreeNodeCollection newNodes = ParseBbsCategory(strBuff.ToString());

			//Xe[^Xo[NA
			obj[0] = "";
			commandController.Form.BeginInvoke(setStatusBarDelegate, obj);

			//݂̃c[2chT[oȊOzigumoT[ȍꎞޔĂ
			model.pushZigumoServerInfo(this.nodes);

			//ޔĂzigumoT[ȍVc[nodesɕA
			model.popZigumoServerInfo(newNodes);
			
			//VɐJeSc[ۑ
			model.SaveCategoryTree(newNodes);

			//CategoryTreeViewN
			UpdateCategoryDelegate updateCategoryDelegate = new UpdateCategoryDelegate(commandController.Form.UpdateCategoryTreeView);
			commandController.Form.BeginInvoke(updateCategoryDelegate);

			Unlock();//lock
		}

		/// <summary>
		/// j[ep[X
		/// </summary>
		/// <param name="textList"></param>
		/// <returns></returns>
		private TreeNodeCollection ParseBbsCategory(string strBuff) {
			TreeView treeView = new TreeView();
			TreeNodeCollection nodes = treeView.Nodes;
			TreeNode node = null;

			//ǂݔ΂
			int index = strBuff.IndexOf(">j[X<", 0);
			index = strBuff.IndexOf("\n", index) + 1;
			node = new TreeNode("j[X", 0, 0);
			nodes.Add(node);//JeSO[v̐ݒ
			string categoryGroupName = node.Text;

			//ǂݍݖ{
			bool jumpFlag = false;
			while(strBuff.Length > index) {
				int endIndex = strBuff.IndexOf("\n", index);
				if(endIndex > -1) {
					int length = endIndex - index;
					string line = strBuff.Substring(index, length);
		
					if(line.IndexOf("<BR><BR><B>", 0) > -1) {
						categoryGroupName = GetCategoryGroupTitle(line);
						if(categoryGroupName == "`bg")//`bgoI
							break;
						if(categoryGroupName == "GknQ" && jumpFlag)//GknĊJ
							jumpFlag = false;

						if(categoryGroupName == "܂aar")//܂BBS͓ǂݔ΂
							jumpFlag = true;

						if(jumpFlag == false) {
							//JeSO[vm[hɒǉ
							node = new TreeNode(categoryGroupName, 0, 0);
							nodes.Add(node);//JeSO[v̐ݒ
						}
					}

					if(line.IndexOf("<A HREF=http://", 0) > -1 && jumpFlag == false) {
						//JeSm[hɒǉ
						BbsCategory category = new BbsCategory();
						string[] str = GetCategoryTitle(line);//JeS̐ݒ
						category.Name = str[1];
Console.WriteLine(categoryGroupName + ":" + str[1]);
						category.CategoryGroup = categoryGroupName;
						//2chڑ̐ݒ
						category.Bbs2chBaseUrl = str[0];
						category.Bbs2chUrl = category.Bbs2chBaseUrl + model.ThreadListFileName;

						TreeNode newNode = new TreeNode(category.Name, 1, 1);
						newNode.Tag = category;
						node.Nodes.Add(newNode);
					}

					index = endIndex + 1;
				} else
					break;
			}

			return nodes;
		}//end ParseBbsCategory

		/// <summary>
		/// JeSO[ṽ^Cg擾郁\bh
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		private string GetCategoryGroupTitle(string text) {
			int startIndex = text.IndexOf("<B>") + 3;
			text = text.Substring(startIndex, text.LastIndexOf("</B>") - startIndex);

			return text;
		}
		/// <summary>
		/// {[hURLƃ^Cg擾郁\bh
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		private string[] GetCategoryTitle(string text) {
			string[] result = {"", ""};

			int startIndex = text.IndexOf("HREF=") + 5;
			int endIndex = text.IndexOf(">", startIndex);
			result[0] = text.Substring(startIndex, endIndex - startIndex);
			startIndex = endIndex + 1;
			endIndex = text.IndexOf("</A>", startIndex);
			result[1] = text.Substring(startIndex, endIndex - startIndex);
			
			return result;
		}
	}//end class
}
