/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ChoiceCategoryTreeDialog.cs,v 1.5 2003/05/07 19:42:28 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

using Zigumo.Model;

namespace Zigumo.DialogObject
{
	/// <summary>
	/// ChoiceCategoryTreeDialog ̊Tv̐łB
	/// </summary>
	public class ChoiceCategoryTreeDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.TreeView categoryTree;
		private System.Windows.Forms.Panel panel;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// fւ̎Q
		/// </summary>
		private ZigumoModel model;
		/// <summary>
		/// IꂽJeS
		/// </summary>
		private BbsCategory selectedCategory;

		/// <summary>
		/// IꂽJeS\vpeB
		/// </summary>
		public BbsCategory SelectedCategory {
			get {
				return selectedCategory;
			}
			set {
				selectedCategory = value;
			}
		}

		public ChoiceCategoryTreeDialog()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();
			
			//model̎擾
			model = ZigumoModel.Model;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.panel = new System.Windows.Forms.Panel();
			this.categoryTree = new System.Windows.Forms.TreeView();
			this.panel.SuspendLayout();
			this.SuspendLayout();
			// 
			// okButton
			// 
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(65, 9);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 0;
			this.okButton.Text = "OK";
			// 
			// cancelButton
			// 
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(153, 9);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 1;
			this.cancelButton.Text = "LZ";
			// 
			// panel
			// 
			this.panel.Controls.AddRange(new System.Windows.Forms.Control[] {
																				this.okButton,
																				this.cancelButton});
			this.panel.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel.Location = new System.Drawing.Point(0, 226);
			this.panel.Name = "panel";
			this.panel.Size = new System.Drawing.Size(292, 40);
			this.panel.TabIndex = 2;
			// 
			// categoryTree
			// 
			this.categoryTree.Dock = System.Windows.Forms.DockStyle.Fill;
			this.categoryTree.ImageIndex = -1;
			this.categoryTree.Name = "categoryTree";
			this.categoryTree.SelectedImageIndex = -1;
			this.categoryTree.Size = new System.Drawing.Size(292, 226);
			this.categoryTree.TabIndex = 3;
			this.categoryTree.DoubleClick += new System.EventHandler(this.categoryTree_DoubleClick);
			this.categoryTree.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.categoryTree_AfterSelect);
			// 
			// ChoiceCategoryTreeDialog
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.CancelButton = this.cancelButton;
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.categoryTree,
																		  this.panel});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ChoiceCategoryTreeDialog";
			this.Text = "ChoiceCategoryTreeDialog";
			this.Load += new System.EventHandler(this.ChoiceCategoryTreeDialog_Load);
			this.panel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// \OɃJeSf[^ǂݍ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ChoiceCategoryTreeDialog_Load(object sender, System.EventArgs e) {
			//݂̃c[NA
			this.categoryTree.Nodes.Clear();

			//JeSc[̓ǂݍ
			ArrayList expandNodes = model.LoadCategoryTree(this.categoryTree.Nodes);

			//I[vȃm[hJ
			foreach(TreeNode openNode in expandNodes) {
				openNode.Expand();
			}
		}

		/// <summary>
		/// IꂽJeSZbg郁\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void categoryTree_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e) {
			TreeNode node = categoryTree.SelectedNode;
			if(node != null)
				selectedCategory = (BbsCategory)node.Tag;
		}

		private void categoryTree_DoubleClick(object sender, System.EventArgs e) {
			this.okButton.PerformClick();
		}//end ChoiceCategoryTreeDialog_Load
	}//end class
}
