/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: Bbs2chThread.cs,v 1.8 2003/05/25 16:43:43 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;

using Zigumo.CommandObject;
using Zigumo.Network;
using Zigumo.View;

namespace Zigumo.Model
{
	/// <summary>
	/// Q̃Xbh\NX
	/// </summary>
	public class Bbs2chThread : BbsThread
	{
		public Bbs2chThread() : base() {
		}

		public Bbs2chThread(BbsCategory category, string text) : base(category, text) {
		}

		/// <summary>
		/// Xbhe\郁\bh
		/// </summary>
		public override void UpdateThread() {
			if(getBbsThread == null || getBbsThread.IsAlive == false) {//݃XbhNłȂꍇXbhN
				//Xbh擾XbhN
				getBbsThread = new Thread(new ThreadStart(GetBbsThread));
				getBbsThread.Start();
			}
		}

		/// <summary>
		/// Xbh擾\郁\bh
		/// </summary>
		public override void GetBbsThread() {
			ZigumoModel model = ZigumoModel.Model;

			//\^ȕу^uy[W䌠̎擾
			SetTabPageControlPermission();

			//Xe[^Xo[XV
			SetStatusBar("XbhXV...");

			//ۑt@C̊mF
			if(!Directory.Exists(CacheDirectoryPath)) {
				Directory.CreateDirectory(CacheDirectoryPath);
			}

			//[JLbVXbh̓ǂݍ
			LoadBbsThreadInfo();
			LoadBbsRes();

			//[JLbVǂݍ񂾏tabPageɏo
			foreach(BbsRes res in resList) {
				if(res.Number > tabPage.ResNumber) {
					WriteRes(res, false);
				}
			}

			//ŐṼXԂn܂邩ۑĂ
			int newResIndex = currentResnum;

			//X擾Jn
			model.Log.Write("Get Thread from " + url);

			Stream st = null;
			StreamByteReader sr = null;
			FileStream   fs = null;
			StreamWriter sw = null;
			try {
				HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(Url);
				httpReq.UserAgent = "Monazilla/1.00 (" + model.ZigumoUserAgent + ")";
				//ځ`񌟏ôߒOsǂ
				//킴1byteÕf[^ǂݍ
				bool returnCodeCheckFlag = false;
				if(size > 0) { size--; returnCodeCheckFlag = true; }

				httpReq.AddRange(size);
				HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();

				//Xg[oRŎ擾
				st = httpRes.GetResponseStream();
				sr = new StreamByteReader(st, Encoding.GetEncoding("Shift_JIS"));

				//擾Xbh̕ۑ
				fs = new FileStream(FilePath, FileMode.Append);
				sw = new StreamWriter(fs, Encoding.UTF8);

				string textLine = null;
				ArrayList removeList = new ArrayList();
				while ((textLine = sr.ReadLine()) != null) {
					//ځ`񌟏o
					if(returnCodeCheckFlag && textLine != "\n") {
						MessageBox.Show("ځ`ɂ郍O폜o܂B\r\ñXbh̃O폜AĎ擾sĂB");
						break;
					}
					if(returnCodeCheckFlag && textLine == "\n") {
						returnCodeCheckFlag = false;
						continue;
					}

					//Xep[X
					BbsRes res = new BbsRes(textLine);
					res.Number = currentResnum++;
					res.BbsThread = this;
					resList.Add(res);

					//ۑ
					sw.Write(textLine);

					//X^uy[Wɏ
					WriteRes(res, true);
				}

				//XbhXgACeXVfQ[gN
				UpdateItem();

				//Xbht@C̕ۑ
				if(sr != null && sr.Size > 0) {
					SaveBbsThreadInfo(sr.Size);
				}

				//ǂݍ񂾃X̍ŐVʒuɃWv
				JumpRes(newResIndex.ToString());

			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} catch(WebException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} catch(UriFormatException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
				if(sw != null) sw.Close();
				if(fs != null) fs.Close();
				if(st != null) st.Close();
			}
			//Xe[^Xo[NA
			SetStatusBar("");
		}

		/// <summary>
		/// Xbh̓ǂݍ
		/// </summary>
		public override void LoadBbsThreadInfo() {
			FileStream fs = null;
			StreamReader sr = null;

			if(!File.Exists(CacheDirectoryPath + threadID + ".info"))
				return;
			try {
				fs = new FileStream(CacheDirectoryPath + threadID + ".info", FileMode.Open);
				sr = new StreamReader(fs, Encoding.UTF8);

				size = 0;
				savedResnum = 0;
				
				string str = null;
				while((str = sr.ReadLine()) != null) {
					if(str.IndexOf("size=") > -1) {
						//擾ς݃TCY̎擾
						string[] strsplit = str.Split('=');
						str = strsplit[1].Trim();
						size = Convert.ToInt32(str);
					} else if(str.IndexOf("resnum=") > -1) {
						//擾ς݃X̎擾
						string[] strsplit = str.Split('=');
						str = strsplit[1].Trim();
						savedResnum = Convert.ToInt32(str);
					}
				}
			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
				if(sr != null)
					sr.Close();
				if(fs != null)
					fs.Close();
			}

		}

		/// <summary>
		/// Xbh̕ۑ
		/// </summary>
		private void SaveBbsThreadInfo(int plusSize) {
			FileStream fs = new FileStream(CacheDirectoryPath + threadID + ".info", FileMode.Create);
			StreamWriter sw = new StreamWriter(fs, Encoding.UTF8);
			size += plusSize;
			sw.WriteLine("size=" + size.ToString());
			sw.WriteLine("resnum=" + (currentResnum - 1).ToString());
			sw.Close();
			fs.Close();
		}

		/// <summary>
		/// ۑĂ郌X̓ǂݍ
		/// </summary>
		protected override void LoadBbsRes() {
			FileStream fs = null;
			StreamReader sr = null;

			if(!File.Exists(FilePath))
				return;
			try {
				//X̓ǂݍ
				fs = new FileStream(FilePath, FileMode.Open);
				sr = new StreamReader(fs, Encoding.UTF8);
				
				string textLine = null;
				int num = 1;
				while((textLine = sr.ReadLine()) != null) {
					if(num++ >= currentResnum) {
						//Xep[X
						BbsRes res = new BbsRes(textLine);
						res.Number = currentResnum++;
						res.BbsThread = this;
						resList.Add(res);
					}				
				}
			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
				if(sr != null)
					sr.Close();
				if(fs != null)
					fs.Close();
			}

			return;
		}

	}//end class
}
