/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: Log.cs,v 1.4 2003/04/25 03:06:50 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.Windows.Forms;
using System.IO;
using System.Text;

namespace Zigumo.Model
{
	/// <summary>
	/// eLXg{bNXAbvf[g֐o^fQ[g
	/// </summary>
	public delegate void UpdateTextBox(string text);

	/// <summary>
	/// OL^pNX
	/// </summary>
	public class Log {
		/// <summary>
		/// OXg\ŕێtB[h
		/// </summary>
		private ArrayList logList = new ArrayList();
		/// <summary>
		/// Oő剽sobt@Ă̐
		/// </summary>
		private int maxLog;
		/// <summary>
		/// Ot@Cɏo͂邩ǂ̃tO
		/// </summary>
		private bool fileOutputFlag = false;//truȅꍇt@Cɏo͂B
		/// <summary>
		/// o͂t@C
		/// </summary>
		private const string fileName = "zigumo";
		/// <summary>
		/// Oo͗pt@CXg[
		/// </summary>
		private FileStream fileStream = null;
		/// <summary>
		/// Oo͗pXg[
		/// </summary>
		private StreamWriter streamWriter = null;
		/// <summary>
		/// Oo͎Ԉꎞۑpϐ
		/// </summary>
		private string keepTime;

		/// <summary>
		/// RXgN^
		/// </summary>
		public Log() : this(300) {
		}

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="max">Oۑobt@s</param>
		public Log(int max) : this(max, false) {
		}

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="max">Oۑobt@s</param>
		/// <param name="fileFlag">t@CۑꍇtrueȂꍇfalse</param>
		public Log(int max, bool fileFlag) {
			maxLog = max;
			fileOutputFlag = fileFlag;

			//t@Co̓[h̏ꍇAt@CI[v
			if(fileOutputFlag) {
				string time = DateTime.Now.ToString("s");
				keepTime = time.Substring(0, 13);
				try {
					fileStream = new FileStream(fileName + time.Substring(0, 13) + ".log", FileMode.Append, FileAccess.Write);
					streamWriter = new StreamWriter(fileStream, Encoding.UTF8);
				} catch (FileNotFoundException e) {
					Console.WriteLine(e);
					Console.WriteLine(e.StackTrace);
				} catch (IOException e) {
					Console.WriteLine(e);
					Console.WriteLine(e.StackTrace);
				} catch (UnauthorizedAccessException e) {
					Console.WriteLine(e);
					Console.WriteLine(e.StackTrace);
				}
			}
		}

		/// <summary>
		/// Oobt@s̃vpeB
		/// </summary>
		public int MaxLog {
			get {
				return maxLog;
			}
			set {
				maxLog = value;
			}
		}
		/// <summary>
		/// Ot@Co͗ptÕvpeB
		/// truȅꍇt@Co͂s
		/// </summary>
		public bool FileOutputFlag {
			get {
				return fileOutputFlag;
			}
			set {
				fileOutputFlag = value;
			}
		}
		/// <summary>
		/// Oo̓\bh
		/// </summary>
		/// <param name="str">Oo͂</param>
		public void Write(string str) {
			string time = DateTime.Now.ToString("s");
			string log = "";

			log = time + " " + str + "\r\n";

			//Oobt@ɒǉ
			if(fileOutputFlag) {
				lock(logList.SyncRoot) {
					logList.Add(log);
					if(logList.Count > maxLog)
						logList.RemoveAt(0);

				}
			}

			//t@Co͏
			if(fileOutputFlag) {
				lock(this) {
					if(keepTime != time.Substring(0, 13)) {
						//ԂƂɏo̓t@Cς鏈
						keepTime = time.Substring(0, 13);
						streamWriter.Close();
						fileStream.Close();
						try {
							fileStream = new FileStream(fileName + time.Substring(0, 13) + ".log", FileMode.Append, FileAccess.Write);
							streamWriter = new StreamWriter(fileStream, Encoding.UTF8);
						} catch (FileNotFoundException e) {
							Console.WriteLine(e);
							Console.WriteLine(e.StackTrace);
						} catch (IOException e) {
							Console.WriteLine(e);
							Console.WriteLine(e.StackTrace);
						} catch (UnauthorizedAccessException e) {
							Console.WriteLine(e);
							Console.WriteLine(e.StackTrace);
						}
					}

					//t@Co
					try {
						streamWriter.Write(log);
					} catch(IOException e) {
						//t@CG[
						Console.WriteLine(e);
						Console.WriteLine(e.StackTrace);
						MessageBox.Show("Ot@Co̓G[łB\r\nOt@Cւ̏o͂~܂B");
						fileOutputFlag = false;
					}
				}//end lock
			}//end if(fileOutputFlag)
		}

		/// <summary>
		/// O擾\bh
		/// </summary>
		/// <returns>obt@̃OSĂstring`ŕԂ</returns>
		public string GetLog() {
			StringBuilder strBuilder = new StringBuilder();
			lock(logList.SyncRoot) {
				for(int i = 0; i < logList.Count; i++) {
					strBuilder.Append(logList[i]);
				}
			}
			return strBuilder.ToString();
		}

		public void Close() {
			streamWriter.Close();
			fileStream.Close();
		}
	}//end Log class
}
