/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ZigumoModel.cs,v 1.19 2003/05/21 17:57:29 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Xml;

using Zigumo.CommandObject;
using Zigumo.MessageObject;
using Zigumo.Model;
using Zigumo.Network;
using Zigumo.View;

namespace Zigumo
{
	/// <summary>
	/// zigumoŜ̃f[^舵fNX
	/// </summary>
	public class ZigumoModel {
		/// <summary>
		/// model̂ւ̎QƁBVOgp^[B
		/// </summary>
		private static readonly ZigumoModel zigumoModel = new ZigumoModel();

		/// <summary>
		/// ZigumoFromւ̎Q
		/// </summary>
		private ZigumoForm zigumoForm;
		/// <summary>
		/// sĂzigumot@C̖
		/// </summary>
		private string applicationName;
		/// <summary>
		/// T[ogIPAhXƃ|[gԍ\EndPoint
		/// </summary>
		private Servent myServent = new Servent(IPAddress.Parse("127.0.0.1"), 6340);
		/// <summary>
		/// Gg[|Cg̃AhX
		/// </summary>
		private string entryPointAddress;
		/// <summary>
		/// BBSj[JĂTCg̃AhX
		/// </summary>
		private string bbsCategoryUrl = "http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html";
		/// <summary>
		/// MAXRlNVTCY
		/// </summary>
		private int maxConnection = 16;
		/// <summary>
		/// ŒRlNVTCY
		/// Œ͕ێĂȂ΂ȂP2PRlNV
		/// </summary>
		private int minConnection = 4;
		/// <summary>
		/// T[og̏
		/// </summary>
		private int serventStatus = (int)MessageObject.ServentStatus.NormalServent;
		/// <summary>
		/// T[ogID
		/// </summary>
		private Guid serventID = Guid.NewGuid();
		/// <summary>
		/// OǗtB[h
		/// </summary>
		private Log log = new Log(1000, true);

		
		//EChETCY

		/// <summary>
		/// EChE̕
		/// </summary>
		private int width;
		/// <summary>
		/// EChE̍
		/// </summary>
		private int height;
		/// <summary>
		/// JeSc[̕
		/// </summary>
		private int splitterWidth;
		/// <summary>
		/// JeS^u̍
		/// </summary>
		private int splitterHeight;


		//`bg֌W

		/// <summary>
		/// `bgT[oNԁBtrueŋN
		/// </summary>
		private bool chatServer = false;
		/// <summary>
		/// `bg[
		/// </summary>
		private string chatName = "";
		/// <summary>
		/// `bgQl
		/// </summary>
		private int chatNumber = 0;
		/// <summary>
		/// `bgQ\ől
		/// </summary>
		private int chatMaxNumber = 0;
		/// <summary>
		/// `bgJeS
		/// </summary>
		private BbsCategory chatCategory;

		
		//uEU֌W
		
		/// <summary>
		/// HTML\̃wb_[
		/// </summary>
		private string htmlHeader = "<html><body><font face=\"lr oSVbN\"><dl>";
		/// <summary>
		/// XHTMLev[g
		/// </summary>
		private string resTemplate = "<a name=\"{NUMBER}\"></a><dt><a href=\"menu:{NUMBER}\">{NUMBER}</a> OF<font color=\"forestgreen\">{NAME}</font> eF{DATE} {ID}<dd>{TEXT}<br><br>";
		/// <summary>
		/// VXHTMLev[g
		/// </summary>
		private string resNewTemplate = "<a name=\"{NUMBER}\"></a><dt><a href=\"menu:{NUMBER}\"><b>{NUMBER}</b></a> OF<font color=\"forestgreen\">{NAME}</font> eF{DATE} {ID}<dd>{TEXT}<br><br>";
		/// <summary>
		/// Xbh擾CxgNbN̂ƂtrueA_uNbN̂Ƃfalse
		/// </summary>
		private bool isClickThreadsGetting = false;
		/// <summary>
		/// e[u`XVXbh̃vpeBD0̂Ƃ͑Sf[^擾Ƀe[uXVD
		/// </summary>
		private int numberOfThreadsToUpdateUI = 0;

		/// <summary>
		/// zigumõo[W
		/// </summary>
		private const string zigumoVersion = "0.2.0";
		/// <summary>
		/// zigumogpĂvgR̃o[W
		/// </summary>
		private const string zigumoProtocolVersion = "0.2";
		/// <summary>
		/// zigumõ[UG[WFg
		/// </summary>
		private const string zigumoUserAgent = "zigumo servent/" + zigumoProtocolVersion;
		/// <summary>
		/// Gg[|Cg̃t@C
		/// </summary>
		private const string entryPointFileName = "entrypoint.dat";
		/// <summary>
		/// BBSj[̃t@C
		/// </summary>
		private const string bbsCategoryFileName = "categorytree.xml";
		/// <summary>
		/// XbhXg̃t@C
		/// </summary>
		private const string threadListFileName = "subject.txt";
		/// <summary>
		/// LbVۑꏊ̃pX
		/// </summary>
		private const string cacheDirectoryPath = "cache/";
		/// <summary>
		/// ꎞۑpnbVe[u
		/// </summary>
		private Hashtable tempCategory;

		/// <summary>
		/// BZigumoModelCX^XԂ
		/// model̂̃vpeB
		/// </summary>
		public static ZigumoModel Model {
			get {
				return zigumoModel;
			}
		}

		/// <summary>
		/// ZigumoForm̃vpeB
		/// </summary>
		public ZigumoForm Form {
			get {
				return zigumoForm;
			}
			set {
				zigumoForm = value;
			}
		}
		/// <summary>
		/// sĂzigumõt@C
		/// </summary>
		public string ApplicationName {
			get {
				return applicationName;
			}
			set {
				applicationName = value;
			}
		}
		/// <summary>
		/// Xi[|[gԍvpeB
		/// </summary>
		public int PortNumber {
			get {
				return myServent.Port;
			}
			set {
				myServent.Port = value;
			}
		}
		/// <summary>
		/// IPEndPointݒvpeB
		/// </summary>
		public Servent MyServent {
			get {
				return myServent;
			}
			set {
				myServent = value;
			}
		}
		/// <summary>
		/// IPAhXݒvpeB
		/// </summary>
		public IPAddress IPAddress {
			get {
				return myServent.Address;
			}
			set {
				myServent.Address = value;
			}
		}
		/// <summary>
		/// Gg[|CgݒvpeB
		/// </summary>
		public string EntryPointAddress {
			get {
				return entryPointAddress;
			}
			set {
				entryPointAddress = value;
			}
		}
		/// <summary>
		/// BBSj[URL̃vpeB
		/// </summary>
		public string BbsCategoryUrl {
			get {
				return bbsCategoryUrl;
			}
			set {
				bbsCategoryUrl = value;
			}
		}
		/// <summary>
		/// MAXRlNVݒvpeB
		/// </summary>
		public int MaxConnection {
			get {
				return maxConnection;
			}
			set {
				maxConnection = value;
			}
		}
		/// <summary>
		/// MINRlNVݒvpeB
		/// </summary>
		public int MinConnection {
			get {
				return minConnection;
			}
			set {
				minConnection = value;
			}
		}
		/// <summary>
		/// T[ogXe[^X̃vpeB
		/// </summary>
		public int ServentStatus{
			get {
				return serventStatus;
			}
			set {
				serventStatus = value;
			}
		}
		/// <summary>
		/// T[ogID̃vpeB
		/// </summary>
		public Guid ServentID {
			get {
				return serventID;
			}
			set {
				serventID = value;
			}
		}
		/// <summary>
		/// OtB[h̃vpeB
		/// </summary>
		public Log Log {
			get {
				return log;
			}
			set {
				log = value;
			}
		}

		
		//EChE֌W

		/// <summary>
		/// EChE̕vpeB
		/// </summary>
		public int Width {
			get {
				return width;
			}
			set {
				width = value;
			}
		}
		/// <summary>
		/// EChE̍vpeB
		/// </summary>
		public int Height {
			get {
				return height;
			}
			set {
				height = value;
			}
		}
		/// <summary>
		/// JeSc[̕
		/// </summary>
		public int SplitterWidth {
			get {
				return splitterWidth;
			}
			set {
				splitterWidth = value;
			}
		}
		/// <summary>
		/// JeS^u̍
		/// </summary>
		public int SplitterHeight {
			get {
				return splitterHeight;
			}
			set {
				splitterHeight = value;
			}
		}


		//`bg֌W

		/// <summary>
		/// `bgT[oNԂ̃vpeB
		/// </summary>
		public bool ChatServer {
			get {
				return chatServer;
			}
			set {
				chatServer = value;
			}
		}
		/// <summary>
		/// `bg[̃vpeB
		/// </summary>
		public string ChatName {
			get {
				return chatName;
			}
			set {
				chatName = value;
			}
		}
		/// <summary>
		/// `bgQl̃vpeB
		/// </summary>
		public int ChatNumber {
			get {
				return chatNumber;
			}
			set {
				chatNumber = value;
			}
		}
		/// <summary>
		/// `bgQől̃vpeB
		/// </summary>
		public int ChatMaxNumber {
			get {
				return chatMaxNumber;
			}
			set {
				chatMaxNumber = value;
			}
		}
		/// <summary>
		/// `bg̃JeS
		/// </summary>
		public BbsCategory ChatCategory {
			get {
				return chatCategory;
			}
			set {
				chatCategory = value;
			}
		}



		//uEU֌W

		/// <summary>
		/// HTMLwb_[̃vpeB
		/// </summary>
		public string HtmlHeader {
			get {
				return htmlHeader;
			}
		}
		/// <summary>
		/// XHTMLev[g̃vpeB
		/// </summary>
		public string ResTemplate {
			get {
				return resTemplate;
			}
		}
		/// <summary>
		/// VXev[g̃vpeB
		/// </summary>
		public string ResNewTemplate {
			get {
				return resNewTemplate;
			}
		}
		/// <summary>
		/// X擾Cxg̃vpeB
		/// </summary>
		public bool IsClickThreadsGetting {
			get {
				return isClickThreadsGetting;
			}
			set {
				isClickThreadsGetting = value;
			}
		}
		/// <summary>
		/// X擾Cxg̃vpeB
		/// </summary>
		public bool IsDoubleClickThreadsGetting {
			get {
				return !isClickThreadsGetting;
			}
			set {
				isClickThreadsGetting = !value;
			}
		}
		/// <summary>
		/// e[u`XVXbh̃vpeB
		/// 0̂Ƃ͑Sf[^擾Ƀe[uXV
		/// </summary>
		public int NumberOfThreadsToUpdateUI {
			get {
				return numberOfThreadsToUpdateUI;
			}
			set {
				numberOfThreadsToUpdateUI = value;
			}
		}
		
		/// <summary>
		/// zigumõo[W̃vpeB
		/// </summary>
		public string ZigumoVersion {
			get {
				return zigumoVersion;
			}
		}
		/// <summary>
		/// zigumogpĂvgR̃vpeB
		/// </summary>
		public string ZigumoProtocolversion {
			get {
				return zigumoProtocolVersion;
			}
		}
		/// <summary>
		/// zigumõ[UG[WFgvpeB
		/// </summary>
		public string ZigumoUserAgent {
			get {
				return zigumoUserAgent;
			}
		}

		/// <summary>
		/// Gg[|Cgt@C̃vpeB
		/// </summary>
		public string EntryPointFileName {
			get {
				return entryPointFileName;
			}
		}
		/// <summary>
		/// BBSj[t@C̃vpeB
		/// </summary>
		public string BbsCategoryFileName {
			get {
				return bbsCategoryFileName;
			}
		}
		/// <summary>
		/// XbhXgt@C̃vpeB
		/// </summary>
		public string ThreadListFileName {
			get {
				return threadListFileName;
			}
		}

		/// <summary>
		/// LbVfBNgpX̃vpeB
		/// </summary>
		public string CacheDirectoryPath {
			get {
				return cacheDirectoryPath;
			}
		}

		/// <summary>
		/// RXgN^B
		/// </summary>
		private ZigumoModel() {
			//t@C̑݃`FbN
			CheckFiles();

			//[hconfigt@C
			LoadConfiguration();
		}

		/// <summary>
		/// ݒt@Cǂݍ݃\bh
		/// </summary>
		private void LoadConfiguration() {
			//Gg[|Cg̓ǂݍ
			//Gg[|Cg͎蓮ŕpɂɏ\邽
			//zigumo.exe.configt@Cɂ͋LqAʃt@CɂPsPAhX
			//`ŕۑ邱ƂƂB
			if(!File.Exists(this.EntryPointFileName)) {//t@C݃`FbN
				//t@C݂ȂꍇIɍ쐬
				FileStream fs = new FileStream(this.EntryPointFileName, FileMode.Create);
				StreamWriter sw = new StreamWriter(fs, Encoding.UTF8);
				sw.Write("http://www.zigumo.org/cgi-bin/zigumo/reflector.cgi");
				sw.Close();
				fs.Close();
			}

			try {
				StreamReader sr = new StreamReader(this.EntryPointFileName, Encoding.GetEncoding("sjis"));
				entryPointAddress = sr.ReadLine();
				sr.Close();
			} catch(IOException e) {
				//t@C֌W̗O
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			}

			//zigumo.exe.configݒt@C̓ǂݍ
			NameValueCollection nv = ConfigurationSettings.AppSettings;
			string str;
			try {
				if((str = nv["PortNumber"]) != null) myServent.Port = Convert.ToInt32(str);
				if((str = nv["IPAddress"]) != null) myServent.Address = IPAddress.Parse(str);
				if((str = nv["Width"]) != null) width = Convert.ToInt32(str);
				if((str = nv["Height"]) != null) height = Convert.ToInt32(str);
				if((str = nv["SplitterWidth"]) != null) splitterWidth = Convert.ToInt32(str);
				if((str = nv["SplitterHeight"]) != null) splitterHeight = Convert.ToInt32(str);
			} catch(Exception e) {
				//ǂݍݎsG[
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
				MessageBox.Show("ݒt@Cǂݍ݃G[");
			}
		}
		/// <summary>
		/// ݒt@C݃\bh
		/// </summary>
		public void SaveConfiguration() {
			//zigumo.exe.configݒt@C̕ۑ
			XmlTextWriter xw = new XmlTextWriter(applicationName + ".config", Encoding.UTF8);
			xw.Formatting = Formatting.Indented;
			xw.WriteStartDocument();
			xw.WriteStartElement("configuration");
			xw.WriteStartElement("appSettings");
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "PortNumber");
			xw.WriteAttributeString("value", myServent.Port.ToString());
			xw.WriteEndElement();
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "IPAddress");
			xw.WriteAttributeString("value", myServent.Address.ToString());
			xw.WriteEndElement();
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "Width");
			xw.WriteAttributeString("value", width.ToString());
			xw.WriteEndElement();
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "Height");
			xw.WriteAttributeString("value", height.ToString());
			xw.WriteEndElement();
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "SplitterWidth");
			xw.WriteAttributeString("value", splitterWidth.ToString());
			xw.WriteEndElement();
			xw.WriteStartElement("add");
			xw.WriteAttributeString("key", "SplitterHeight");
			xw.WriteAttributeString("value", splitterHeight.ToString());
			xw.WriteEndElement();
			xw.WriteEndElement();
			xw.WriteEndElement();
			xw.Close();
		}
		
		/// <summary>
		/// JeSc[̓ǂݍ݃\bh
		/// </summary>
		/// <param name="nodes">ǂݍݐ̃m[hRNV</param>
		/// <returns>WJĂm[ḧꗗ</returns>
		public ArrayList LoadCategoryTree(TreeNodeCollection nodes) {
			ArrayList expandNodes = new ArrayList();//Jm[hێĂ
			TreeNode node = null;
			BbsCategory category = null;

			//BBS^Öꎞێpϐ
			string bbsAttributeType = null;
			string bbsAttributeUrl = null;
			string categoryGroupName = null;

			XmlTextReader rdr = new XmlTextReader(BbsCategoryFileName);
			while(rdr.Read()) {
				switch (rdr.NodeType) {

					case XmlNodeType.Element:
						if(rdr.Name == "categoryGroup") {
							//JeSO[vm[h̒ǉ
							string openCloseFlag = null;
							while (rdr.MoveToNextAttribute()) {
								if(rdr.Name == "name") {
									categoryGroupName = rdr.Value;
								} else if(rdr.Name == "openClose") {
									openCloseFlag = rdr.Value;
								}
							}
							node = new TreeNode(categoryGroupName, 0, 0);
							nodes.Add(node);
							if(openCloseFlag == "-")//tO-ȂI[v+ȂN[Y
								expandNodes.Add(node);//I[vȃm[hێ
						} else if(rdr.Name == "category") {
							//JeSm[h̒ǉ
							category = new BbsCategory();
							category.CategoryGroup = categoryGroupName;
							while(rdr.MoveToNextAttribute()) {
								if(rdr.Name == "name") {
									category.Name = rdr.Value;
								}
							}
						} else if(rdr.Name == "bbs") {
							//BBS̐ݒ
							while(rdr.MoveToNextAttribute()) {
								if(rdr.Name == "type") {
									bbsAttributeType = rdr.Value;
								} else if(rdr.Name == "url") {
									bbsAttributeUrl = rdr.Value;
								}
							}
							//BBS^Oݒ
							if(bbsAttributeType == "2ch") {
								//2chڑ̐ݒ
								category.Bbs2chBaseUrl = bbsAttributeUrl;
								category.Bbs2chUrl = category.Bbs2chBaseUrl + ThreadListFileName;
							} else if(bbsAttributeType == "zigumo") {
								//zigumoڑ̐ݒ
								//ȂAzigumo̐ڑ͕݂ꍇB
								category.ZigumoBaseUrl.Add(bbsAttributeUrl);
							}
						}
						break;
					case XmlNodeType.EndElement:
						if(rdr.Name == "category") {
							//JeSm[h̒ǉ
							TreeNode newNode = new TreeNode(category.Name, 1, 1);
							newNode.Tag = category;
							node.Nodes.Add(newNode);
						}
						break;

				}

			}
			rdr.Close();
			return expandNodes;
		}

		/// <summary>
		/// JeSc[̕ۑ\bh
		/// </summary>
		/// <param name="nodes">ۑm[hRNV</param>
		public void SaveCategoryTree(TreeNodeCollection nodes) {
			XmlTextWriter xw = null;
			try {
				//JeSc[XMLt@Cɕۑ
				xw = new XmlTextWriter(BbsCategoryFileName, Encoding.UTF8);
				xw.Formatting = Formatting.Indented;
				xw.WriteStartDocument();
				xw.WriteStartElement("categoryTree");

				bool elementStartFlag = false;
				foreach(TreeNode node in nodes) {
					if(node.Tag == null) {//ۂ̃JeS񂪂邩Bꍇ͑啪ރm[hBꍇ͎ۂ̃JeSm[h
						//JeSO[vm[h̕ۑ
						//啪ނ̕ۑBqm[hiJeSm[hj̊JԂۑB
						string openCloseFlag = "";
						if(node.IsExpanded)
							openCloseFlag = "-";
						else
							openCloseFlag = "+";

						if(elementStartFlag)
							xw.WriteEndElement();
						else
							elementStartFlag = true;

						xw.WriteStartElement("categoryGroup");
						xw.WriteAttributeString("name", node.Text);
						xw.WriteAttributeString("openClose", openCloseFlag);
					}
					if(node.Nodes != null) {//qm[hiJeSm[hj邩
						//qm[hiJeSm[hj̕ۑ
						TreeNodeCollection childNodes = node.Nodes;
						foreach(TreeNode childNode in childNodes) {
							//JeSm[h̕ۑ
							BbsCategory category = (BbsCategory)childNode.Tag;

							//JeS^O̕ۑ
							xw.WriteStartElement("category");
							xw.WriteAttributeString("name", childNode.Text);
							
							//2ch BBS^O̕ۑ
							if(category.Bbs2chBaseUrl != null || category.Bbs2chBaseUrl != "") {
								xw.WriteStartElement("bbs");
								xw.WriteAttributeString("type", "2ch");
								xw.WriteAttributeString("url", category.Bbs2chBaseUrl);
								xw.WriteEndElement();
							}
							//zigumo BBS^O̕ۑ(zigumõT[o͕\̂ŁA[v)
							if(category.ZigumoBaseUrl != null) {
								foreach(string url in category.ZigumoBaseUrl) {
									xw.WriteStartElement("bbs");
									xw.WriteAttributeString("type", "zigumo");
									xw.WriteAttributeString("url", url);
									xw.WriteEndElement();
								}
							}
							//JeS^O
							xw.WriteEndElement();
						}
					}
				}
				xw.WriteEndElement();
				xw.Close();
			} catch(IOException e) {
				//t@C֌W̗O
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			}
		}
		
		/// <summary>
		/// JeS̍XVɁAzigumoT[ȍ񂪍폜ȂpꎞI
		/// ۑĂBpopZigumoSerInfo\bhɂTreeNodeCollection
		/// ɕA邱ƂłB
		/// </summary>
		/// <param name="nodes"></param>
		public void pushZigumoServerInfo(TreeNodeCollection nodes) {
			this.tempCategory = new Hashtable();

			//[vł܂킵Č݂̃JeS擾ĂB
			foreach(TreeNode node in nodes) {
				//qm[hiJeSm[hj̕ۑ
				TreeNodeCollection childNodes = node.Nodes;
				foreach(TreeNode childNode in childNodes) {
					BbsCategory category = (BbsCategory)childNode.Tag;
					this.tempCategory[category.CategoryID] = category;//ꎞJeSۑ
				}
			}
		}

		/// <summary>
		/// JeS̍XVɑޔĂzigumȍCategoryTreeɕA郁\bh
		/// </summary>
		/// <param name="nodes"></param>
		public void popZigumoServerInfo(TreeNodeCollection nodes) {
			//[vł܂킵Č݂̃JeS`FbN
			foreach(TreeNode node in nodes) {
				//qm[hiJeSm[hj̕ۑ
				TreeNodeCollection childNodes = node.Nodes;
				foreach(TreeNode childNode in childNodes) {
					BbsCategory category = (BbsCategory)childNode.Tag;
					BbsCategory pushCategory = (BbsCategory)this.tempCategory[category.CategoryID];
					if(pushCategory != null) {//ޔĂJeSɓ̂Ȃ
						//ޔĂJeS𕜋A
						category.ZigumoBaseUrl = pushCategory.ZigumoBaseUrl;
						category.ZigumoUrl = pushCategory.ZigumoUrl;
					}
				}
			}
		}

		/// <summary>
		/// t@C̑݃`FbN\bh
		/// Kvȃt@C`FbNA݂Ȃꍇ쐬
		/// </summary>
		public void CheckFiles() {
			if(!Directory.Exists(this.CacheDirectoryPath + "2ch")) {
				Directory.CreateDirectory(this.CacheDirectoryPath + "2ch");
			}
			if(!Directory.Exists(this.CacheDirectoryPath + "zigumo")) {
				Directory.CreateDirectory(this.CacheDirectoryPath + "zigumo");
			}
		}
		/// <summary>
		/// BBSJeSj[XV
		/// </summary>
		public void UpdateCategoryTree(TreeNodeCollection nodes) {
			CommandController commandController = CommandController.Controller;
			commandController.PutCommand(new GetBbsCategoryTreeCommand(nodes));
		}

	}//end class
}
